/***********************************************************
naver
***********************************************************/
var hostString="";
var supportInboxOnly=true;
var supportShowFolders=true;

function init(){
  this.initStage=ST_PRE;
  this.dataURL="http://mail.naver.com";
  this.loginData=["https://nid.naver.com/nidlogin.login",
                      "id","pw",
                      "enctp=1"];
  this.mailURL="http://mail.naver.com";
  this.mailDomain="mail.naver.com";  

  this.cookieDomain="naver.com";    

  this.logoutURL="http://nid.naver.com/nidlogin.logout";  
}
function process(aHttpChannel, aData) {
  switch(this.stage){
  case ST_PRE:  
    this.getHtml("http://static.nid.naver.com/enclogin/keys.nhn");
    return false;
  case ST_PRE_RES:
    var keys=aData.split(",");
    var sessionkey = keys[0];
    var keyname = keys[1];
    var evalue = keys[2];
    var nvalue = keys[3];
    var rsa = new RSAKey();
    rsa.setPublic(evalue, nvalue);
    var encpw=rsa.encrypt(this.getLenChar(sessionkey) + sessionkey
					+ this.getLenChar(this.user)+this.user
					+ this.getLenChar(this.password)+this.password);   
    this.stage=ST_LOGIN_RES;
    this.getHtml(this.loginData[LOGIN_URL],"enctp=1&encpw="+encpw+"&encnm="+keyname);         
    return true;
  case ST_LOGIN_RES:
    var fnd=aData.match(/replace\("(\S+?)"/);
    if(fnd){
      this.stage=ST_DATA;
      this.getHtml(decodeURIComponent(fnd[1]));
      return true;
    }
  }
  return this.baseProcess(aHttpChannel, aData);
}

function getData(aData){
  var obj={};
  this.folders={};//used for direct link
  var re=/{\"FolderSN\":\"(\S+?)\",\"FolderType\":\"(.+?)\".+?\"FolderName\":\"(.+?)\",\"UnreadMailCount\":\"(\d+)\"/g;
  var o;
  var ar=[];
  this.mailCount=0;
  var found=false;
  while ((o = re.exec(aData)) != null){
    if(o[2]=="S"&&o[1]!="0")continue;
    var found=true;
    var n=parseInt(o[4]);    
    if(this.inboxOnly){
      if(o[1]=="0")this.mailCount=n;
    }else this.mailCount+=n;
    if(n>0&&o[1]!="0"){
      var name=unescape(o[3].replace(/\\/g,"%"));
      this.folders[name]=o[1];    
      ar.push(name);
      ar.push(n);
    }
  }
  if(this.showFolders){
    if(ar)obj.folders=ar;  
  }
  if(!found)this.mailCount=-1;
  return obj;
}
function getMailURL(aFolder){
  if(aFolder){
    return "http://mail.naver.com/list/"+this.folders[aFolder];
  }
  return this.mailURL;  
}

function getLenChar(texts) {
	texts = texts + '';
	return String.fromCharCode(texts.length);
}