/***********************************************************
Yahoo
***********************************************************/
 var supportInboxOnly=true;
 var supportShowFolders=true;
 var supportIncludeSpam=true;
 
function init(){
  this.initStage=ST_PRE;
  var ar=this.user.split("@");
  if(ar[1]=="yahoo.co.jp"){
    this.loginData=["https://login.yahoo.co.jp/config/login?",
                        "","passwd","login="+encodeURIComponent(ar[0])];
    this.dataURL="http://mail.yahoo.co.jp/"
    this.mailURL="http://mail.yahoo.co.jp/";
    this.mailDomain="mail.yahoo.co.jp";
    this.domain="yahoo.co.jp";
    this.loginData[3]+="&.persistent=y";
  }else{
    this.loginData=["https://login.yahoo.com/config/login",
                        "login","passwd",".ws=1&.persistent=y"];
    this.dataURL="http://mail.yahoo.com/"
    this.mailURL="http://mail.yahoo.com/";
    this.mailDomain="mail.yahoo.com";
    this.domain="yahoo.com";
  }
}
function checkLogin(aData,aHttpChannel){
  switch(this.stage){
  case ST_CHECK:
    this.getHtml(this.dataURL);
    return false;
  case ST_CHECK+1:  
    var fnd=aData.match(/<form.+?name="login_form"/);
    if(!fnd){//logged in already 
      this.stage=ST_DATA;
      return this.process(aHttpChannel,aData);        
    }else{
      this.cookieManager.clear();//clear cookies because 'F' is saved    
      this.stage=this.initStage;
      return this.process(null,"");
      //this.getHtml(this.logoutURL);
      //return true;
    }  
  }
  this.onError();
  return true;  
}
function process(aHttpChannel, aData) {
  switch(this.stage){
  case ST_PRE:
    if(this.domain=="yahoo.com"){
      var done=false;
      try{
        var s=this.main.prefBranch.getCharPref("accounts."+this.id+"."+this.user+".cookie");
        s=s.split("\t");
        var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                        .getService(Components.interfaces.nsIIOService);
        var uri=ioService.newURI(s[0],null,null);
        this.cookieManager.addCookies(uri,s[1]);
        done=true;
      }catch(e){}
      if(!done){
        var ck=this.getCookieString(this.domain,"F");
        if(ck){     
          this.cookieManager.addCookies("http://login."+this.domain,ck);
        }
      }    
    }
    this.mode=-1;
    this.stage=this.domain=="yahoo.co.jp"?ST_PRE+1:ST_LOGIN;    
    this.getHtml(this.dataURL);//set cookie for login
    return true;
  case ST_PRE+1://yahoo.co.jp
    var fnd=aData.match(/\(".albatross"\)\[0\].value\s*=\s*"(\S+?)"/);
    if(fnd)this.albatross="&.albatross="+encodeURIComponent(fnd[1]);
    this.stage=ST_LOGIN;
    this.delay(4000);
    return true;
  case ST_LOGIN:
    if(this.albatross){
      this.getHtml(this.loginData[LOGIN_URL],this.loginData[LOGIN_POST]+this.albatross);
      delete this.albatross;
      return false;
    }
    break;
  case ST_LOGIN_RES:
    var fnd=aData.match(/"code"\s*:\s*"1213"/);
    if(fnd){
      if(this.main.prefBranch.getBoolPref("yahoo.showCaptcha")){
        this.stage=ST_LOGIN_RES+3;
        this.getHtml("https://login.yahoo.com/captcha/CaptchaWSProxyService.php?action=createlazy&initial_view=&.intl=us&.lang=en-US&rnd="+new Date().getTime());
        return true;
      }
      this.onError();
      return true;
    }
    if(this.domain=="yahoo.com"){
      var s=this.cookieManager.findCookieString(this.domain,"F");
      if(s){
        this.main.prefBranch.setCharPref("accounts."+this.id+"."+this.user+".cookie",aHttpChannel.URI.spec+"\t"+s);
      }
    }
    this.stage=ST_LOGIN_RES+1;
  case (ST_LOGIN_RES+1):
    this.getHtml(this.dataURL);
    return false;
    break;
  case (ST_LOGIN_RES+2):
    var fnd=aData.match(/doAction\(\'(\S+?)\',\s*?\'(\S+?)\'/);
    if(fnd){//not supported os or browser
      this.stage=ST_DATA;
      this.getHtml("http://"+this.channel.URI.host+"/dc/system_requirements.php","a="+fnd[1]+"&crumb="+encodeURIComponent(fnd[2]));
      return true;
    }
    fnd=aData.match(/launch\?reason=ignore&rs=1|optOut\?rs=1\S+?once=true/);
    if(fnd){
      var fnd2=aData.match(/servername:"(\S+?)"/);
      if(fnd2){
        this.dataURL="http://"+fnd2[1]+"/neo/"+fnd[0];
        //this.mailURL=this.dataURL;
        this.stage=ST_DATA;     
        break;        
      }
    }
    fnd=aData.match(/location.replace\("(\S+?launch\?\S+?)"/);
    if(fnd){//https everywhere
      this.dataURL=fnd[1];
      this.stage=ST_DATA;     
      break;
    }    
    this.stage=ST_DATA_RES;
    break;
  case (ST_LOGIN_RES+3)://captcha
    aData=aData.replace(/&amp;/g,"&").replace(/&quot;/g,"\"").replace(/&lt;/g,"<").replace(/&gt;/g,">").replace(/&apos;/g,"'");  
    var post=this.getForm(aData);
    var fnd=aData.match(/id="captchaV5ClassicCaptchaImg".+?src="(\S+?)"/);    
    if(post&&fnd){
      var rs=this.main.openCaptchaDialog(this.id,this.user,fnd[1]);
      if(rs){        
        post=post.replace(/captchaAnswer=/,"captchaAnswer="+encodeURIComponent(rs));
        this.getHtml(this.loginData[LOGIN_URL],this.loginData[LOGIN_POST]+"&.cp=1&"+post);
        this.stage=ST_LOGIN;
        return false;
      }    
    }
  }
  return this.baseProcess(aHttpChannel, aData);
}

function getData(aData){
  var obj={};
  var ar=[];
  this.folders={};//used for direct link
  if(this.mode==null||this.mode<0){
    var fnd=aData.match(/.folders\s*?=/);
    if(fnd)this.mode=2;
    else{
      fnd=aData.match(/<div.+?folderlist.+?>([\s\S]+?)<div class=\"last\">/);
      this.mode=fnd?1:0;
    }
  }
  if(this.mode==2){
    if(this.includeSpam&&this.spamName==null){
      var fnd=aData.match(/str_nav_spam:"(.+?)"/);
      if(fnd)this.spamName=fnd[1];
      else this.spamName="Spam--";
    }
    var fnd=aData.match(/.folders\s*?=\s*?{([\s\S]+?)}\s*;/);
    if(fnd){
      var num=0;
      var re=/"fid":"(.+?)".+?"name":"(.+?)".+?"unread":(\d+)/g;
      var o;
      while ((o = re.exec(fnd[1])) != null){ 
        if(!this.includeSpam&&o[1]=="%40B%40Bulk")continue;
        if(o[1]=="Draft")continue;
        if(o[1]=="Sent")continue;
        if(o[1]=="Trash")continue;
        var n=0
        if(o[3])n=parseInt(o[3]);        
        if(this.inboxOnly){
          if(o[1]=="Inbox")num+=n;          
          if(this.includeSpam&&o[1]=="%40B%40Bulk")num+=n;
        }else num+=n;
        if(n>0&&o[1]!="Inbox"){
          if(o[1]=="%40B%40Bulk")ar.push(this.spamName);
          else ar.push(unescape(o[2].replace(/\\u/g,"%u")));
          ar.push(n);
        }                
      }
      this.mailCount=num;
      if(this.showFolders){
        if(ar)obj.folders=ar;
      }
      return obj;  
    }
  }else if(this.mode==1){//original mode
    var fnd=aData.match(/<div.+?folderlist.+?>([\s\S]+?)<div class=\"last\">/);
    if(fnd){
      fnd=fnd[1];
      if(!this.inboxOnly||this.showFolders){
        var fnd2=aData.match(/<div.+?customfolders.+?>([\s\S]+?)<div class=\"last\">/);
        if(fnd2){
          fnd+=fnd2[1];
        }
      }
      fnd=fnd.match(/<li .+?<\/a>/g);
      if(fnd){
        var s;
        var num=0;
        for(var i=0;i<fnd.length;i++){
          s=fnd[i];
          var t=s.match(/li\s+id=\"(.+?)\".+?<a.+?>(?:<em>)?(.+?)(?:\s\S+?(\d+)\S+)?<\/a>/);
          if(t){
            if(t[1]=="draft"||t[1]=="sent"||t[1]=="receipt"
              ||t[1]=="bulk"||t[1]=="trash")continue;
            var n=0;
            if(t[3])n=parseInt(t[3]);
            if(this.inboxOnly){
              if(t[1]=="inbox")num=n;
            }else num+=n;
            if(n>0&&t[1]!="inbox"){
              var fid=t[1];
              if(fid.indexOf("%")==0)fid=fid.substring(1,fid.length-1);
              this.folders[t[2]]=fid;
              ar.push(t[2]);
              ar.push(n);
            }
          }
        }
        this.mailCount=num;
        if(this.showFolders){
          if(ar)obj.folders=ar;
        }
        return obj;
      }    
    }
  }else{
    fnd=aData.match(/<ListFoldersResponse>([\s\S]+?)<\/ListFoldersResponse>/);
    if(fnd){
      fnd=fnd[1].match(/<folder.+?<\/folder>/g);
      if(fnd){
        var s;
        var num=0;
        for(var i=0;i<fnd.length;i++){
          s=fnd[i];                    
          s=s.match(/unread=\\?\"(\d+)\\?\".+?fid=\\?\"(.+?)\\?\".+?name=\\?\"(.+?)\\?\"/);          
          if(s){
            if(s[2]=="%40B%40Bulk"||s[2]=="Draft"
              ||s[2]=="Sent"||s[2]=="Trash")continue;
            var n=0;
            if(s[1])n=parseInt(s[1]);
            if(this.inboxOnly){
              if(s[2]=="Inbox")num=n;
            }else num+=n;
            if(n>0&&s[2]!="Inbox"){
              var name=s[3];
              name=unescape(name.replace(/&#x(\w+);/g,function(){return "%u"+RegExp.$1;}));
              ar.push(name);
              ar.push(n);
            }            
          }
        }
        this.mailCount=num;
        if(this.showFolders){
          if(ar)obj.folders=ar;
        }
        return obj;
      }
    }
  }
  this.mailCount=-1;
  return obj;
}
function getMailURL(aFolder){
  if(this.mode==1&&aFolder&&this.dataURLCopy){
    var n=this.dataURLCopy.indexOf("/",7);
    var url=this.dataURLCopy.substring(0,n)
              +"/mc/showFolder?fid="+encodeURIComponent(this.folders[aFolder]);
    return url;
  }
  return this.mailURL;  
}
