if(com.tobwithu.wmn.p_getBoolPref("multiSession")&&com.tobwithu.wmn.p_getBoolPref("keepSession")){
  com.tobwithu.wmn.getSid=function(){
    return getBrowser().selectedTab.getAttribute("wmnsid");
  };  
  com.tobwithu.wmn.onContentAreaClick=function(e){ 
    switch (e.button){
    case 0:      
      if(e.altKey||e.ctrlKey||e.metaKey||e.shiftKey)return;      
      var sid=com.tobwithu.wmn.getSid();
      if(!sid)return;
      var em=e.target;
      var link=null;
      while(em){   
        if((em instanceof HTMLAnchorElement && em.href) ||
                      em instanceof HTMLAreaElement ||
                      em instanceof HTMLLinkElement ||
                      (em.getAttributeNS&&em.getAttributeNS( "http://www.w3.org/1999/xlink", "type") == "simple" )){
          link=em;
          break;
        }
        em=em.parentNode;
      }    
      if(link){
        if(link.target=="_blank"||link.getAttributeNS("http://www.w3.org/1999/xlink", "show")=="new"){        
          var href=link.href;
          if(!href)href=link.getAttributeNS("http://www.w3.org/1999/xlink", "href");
          var newWin=gPrefService.getIntPref("browser.link.open_newwindow")==2;     
          com.tobwithu.wmn.openURL(href,sid,newWin,false);          
          e.preventDefault();
        }
      }
      break;
    }  
  };
  com.tobwithu.wmn.openNewWindowWith=openNewWindowWith;
  openNewWindowWith=function(aURL, aDocument, aPostData, aAllowThirdPartyFixup,aReferrer){  
    var sid=com.tobwithu.wmn.getSid();
    if(!sid)return com.tobwithu.wmn.openNewWindowWith(aURL, aDocument, aPostData, aAllowThirdPartyFixup,aReferrer);
    else{
      return com.tobwithu.wmn.openURL(aURL,sid,true,false);    
    }
  };

  com.tobwithu.wmn.openNewTabWith=openNewTabWith;
  openNewTabWith=function(aURL, aDocument, aPostData, aEvent, aAllowThirdPartyFixup,aReferrer){
    var sid=com.tobwithu.wmn.getSid();
    if(!sid)return com.tobwithu.wmn.openNewTabWith(aURL, aDocument, aPostData, aEvent, aAllowThirdPartyFixup,aReferrer);
    else{
      var bg = getBoolPref("browser.tabs.loadInBackground");
      if (aEvent && aEvent.shiftKey)bg = !bg;
      return com.tobwithu.wmn.openURL(aURL,sid,false,bg);    
    }
  };  
  if(typeof openLinkIn != "undefined"){
    com.tobwithu.wmn.openLinkIn=openLinkIn;
    openLinkIn=function(url, where, params){
      var sid=com.tobwithu.wmn.getSid();
      switch(where){
      case "window":
        com.tobwithu.wmn.openURL(url,sid,true,false);
        break;
      case "tab":
        var bg = getBoolPref("browser.tabs.loadInBackground");
        com.tobwithu.wmn.openURL(url,sid,false,bg);
        break;
      case "tabshifted":
        var bg = getBoolPref("browser.tabs.loadInBackground");
        com.tobwithu.wmn.openURL(url,sid,false,!bg);
        break;
      default:
        com.tobwithu.wmn.openLinkIn(url, where, params);
      }
    }  
  }
  com.tobwithu.wmn.openURL = function(url,sessionId,newWin,bg) {
    var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                        .getService(Components.interfaces.nsIWindowMediator);
    var win = wm.getMostRecentWindow("navigator:browser");
    if(newWin){
      win.open("about:blank");
      win = wm.getMostRecentWindow("navigator:browser");
    }  
    var tabbrowser=win.getBrowser();  
    var tab;
    if(newWin){
      tab=tabbrowser.selectedTab;
    }else{
      try{
        tab=tabbrowser.addTab("about:blank",{relatedToCurrent:true});
      }catch(e){
        tab=tabbrowser.addTab("about:blank");  
      }  
    }
    var browser=tabbrowser.getBrowserForTab(tab);
    if(sessionId!=null&&sessionId!=""){
      tab.setAttribute("wmnsid",sessionId);   
      try{browser.addProgressListener(com.tobwithu.wmn.nsIWebMailNotifier);}catch(e){};
    }
    if(!bg)tabbrowser.selectedTab = tab;  
    browser.loadURIWithFlags(url);  
    return newWin?win:tab;
  };
  com.tobwithu.wmn.onLoadFF=function(){
    getBrowser().addEventListener("click", com.tobwithu.wmn.onContentAreaClick, false);
    //window.removeEventListener("load", com.tobwithu.wmn.onLoadWin, false);
  };  
  //window.addEventListener("load", com.tobwithu.wmn.onLoadWin, false);

/*  com.tobwithu.wmn.onTabOpen=function(event){
dout(event.target);
  };
  getBrowser().tabContainer.addEventListener("TabOpen", com.tobwithu.wmn.onTabOpen, false);  */
/*  
  com.tobwithu.wmn.init=function(){
    var appcontent = document.getElementById("appcontent");
    if(appcontent)appcontent.addEventListener("DOMContentLoaded", com.tobwithu.wmn.onPageLoad, true);  
  };
  com.tobwithu.wmn.onPageLoad=function(){
    document.getElementById('content').contentWindow.wrappedJSObject.open=...
  };
  window.addEventListener("load", function() { com.tobwithu.wmn.init(); }, false);*/
}
com.tobwithu.wmn.showToolbarButton=function(){
  var id="wmn-toolbar-button";
  var anchor="search-container";
  try {
    var toolbar = document.getElementById("nav-bar");
    var curSet = toolbar.currentSet.split(",");
    if (curSet.indexOf(id) == -1){
      var ind = curSet.indexOf(anchor);
      var pos = ind==-1?curSet.length:ind;
      var set = curSet.slice(0, pos).concat(id).concat(curSet.slice(pos)).join(",");
    
      toolbar.setAttribute("currentset", set);
      toolbar.currentSet = set;
      document.persist("nav-bar", "currentset");
      try {
         BrowserToolboxCustomizeDone(true);
      }catch (e) { }
    }
  }catch(e) { }  
}
com.tobwithu.wmn.initTabMenu=function(){
  if(!document.getElementById("wmnTabMenu"))return;//ff2
  var menu=gBrowser.tabContextMenu;
  if(!menu)menu=document.getAnonymousElementByAttribute(gBrowser, "anonid", "tabContextMenu");//ff 2.0
  if(!menu)return;
  var mi = menu.childNodes;
  var n=0;
  var sep=null;
  for(var i=0;i<mi.length;i++) {
    if (mi[i].localName=="menuseparator"){
      if(n==1){sep=mi[i];break;}
      ++n;
    }
  }
  var menu2=document.getElementById("wmnTabMenu").firstChild;
  menu2.addEventListener("popupshowing",com.tobwithu.wmn.onPopupShow,false);  
  var wmn=com.tobwithu.wmn.nsIWebMailNotifier;
  var hdls=wmn.webMailHandlers;
  var tf=com.tobwithu.wmn.p_getBoolPref("autoLoginDefaultAccount");  
  var sid=gBrowser.selectedTab.getAttribute("wmnsid");
  var show=false;  
  for(var i=0;i<hdls.length;i++){
    var o=hdls[i];
    if(!o.enabled)continue;    
    if(!tf||!wmn.isDefault(o.id,o.user)){
      show=true;
      var em=document.createElement("menuitem");
		  em.setAttribute("label",o.accName);
      em.setAttribute("type","checkbox");
		  em.setAttribute("oncommand","com.tobwithu.wmn.setSessionId("+o.ind+")");
      em.setAttribute("val",o.ind.toString());
      menu2.appendChild(em);
    }
  }
  if(show){
    menu.insertBefore(document.createElement("menuseparator"),sep);
    menu.insertBefore(document.getElementById("wmnTabMenu"), sep);  
  }
}
com.tobwithu.wmn.onPopupShow=function(event){
  var tab=document.popupNode;
  var sid=tab.getAttribute("wmnsid"); 
  if(sid=="")sid=-1; 
  var list=document.getElementById("wmnTabMenu").firstChild.childNodes;
  for(var i=0;i<list.length;i++){
    var val=list[i].getAttribute("val");
    if(val!=sid)list[i].removeAttribute("checked");
    else list[i].setAttribute("checked",true);
  }
}
com.tobwithu.wmn.setSessionId=function(sid){
  com.tobwithu.wmn.nsIWebMailNotifier.setSessionId(window,document.popupNode,sid);
}
