function loadListener(){
  this.removeEventListener("load", loadListener, true);
  this.loadURIWithFlags(this.getAttribute("wmn_url"));            
  this.removeAttribute("wmn_url");
}
WebMailNotifier.prototype.openTab = function(url,name,reuse,mailDomain,sessionId,newWin) {
  var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
           .getService(Components.interfaces.nsIWindowMediator);
  var win = wm.getMostRecentWindow("navigator:browser");
  if(win==null){
    win=this.getWindow(true);     
    var pref = Components.classes["@mozilla.org/preferences-service;1"]
                  .getService(Ci.nsIPrefService)
                  .getBranch("");                  
    if(pref.getIntPref("browser.startup.page")==3){
      var self=this;
      /*win.gBrowser.addEventListener("SSTabRestored", function(aEvent) { //not work in ff4   
        win.gBrowser.removeEventListener("SSTabRestored",this,false);
        self._openTab(url,name,reuse,mailDomain,sessionId,newWin);
      },false);*/
      var timer = Components.classes["@mozilla.org/timer;1"].createInstance(Ci.nsITimer);
      var tmp={
        notify:function(aTimer){
          self._openTab(url,name,reuse,mailDomain,sessionId,newWin);
        }
      };
      timer.initWithCallback(tmp,300,Ci.nsITimer.TYPE_ONE_SHOT);      
      return;
    }
  }
  this._openTab(url,name,reuse,mailDomain,sessionId,newWin);
}  
WebMailNotifier.prototype._openTab =function(url,name,reuse,mailDomain,sessionId,newWin){
  if(reuse){
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
              .getService(Components.interfaces.nsIWindowMediator);  
    var enm = wm.getEnumerator("navigator:browser");
    function calcSid(sid){
      if(sid==null||sid.toString()=="")return -1;
      else return sid;
    }
    while(enm.hasMoreElements()){
      var win=enm.getNext();
      var tabbrowser = win.getBrowser();
      for (var i = 0;i< tabbrowser.mTabContainer.childNodes.length;i++){
        var tab = tabbrowser.mTabContainer.childNodes[i];
        if (tab.hasAttribute("wmntab")&&tab.getAttribute("wmntab")==name) {
          var browser=tabbrowser.getBrowserForTab(tab);
          if(this.canReuse(browser.currentURI,mailDomain)&&(!this.multiSession||calcSid(tab.getAttribute("wmnsid"))==calcSid(sessionId))){
            if(this.prefBranch.getBoolPref("reloadTab")||(!this.multiSession&&tab.getAttribute("wmnid")!=sessionId)||!mailDomain){
              if(!this.multiSession&&name=="gmail"){
                browser.setAttribute("wmn_url",url);
                browser.addEventListener("load", loadListener, true);            
                browser.loadURIWithFlags("about:blank");            
              }else browser.loadURIWithFlags(url);
              if(sessionId!=null){
                if(this.multiSession)this.setSessionId(win,tab,sessionId);
                else tab.setAttribute("wmnid",sessionId); 
              }
            }
            if(!this.prefBranch.getBoolPref("loadInBackground")){
              tabbrowser.selectedTab = tab;
              tabbrowser.contentWindow.focus();            
            }
            return;
          }else{
            tab.removeAttribute("wmntab");
            if(!this.multiSession)tab.removeAttribute("wmnid");
            else try{browser.removeProgressListener(this);}catch(e){}                
          }
        }
      }
    }
  }
  //not found
  var win=this.getWindow(true);
  if(newWin){
    win.open("about:blank");
    var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                        .getService(Components.interfaces.nsIWindowMediator);
    win = wm.getMostRecentWindow("navigator:browser");
  }
  var tabbrowser=win.getBrowser();
  var tab = tabbrowser.selectedTab;
  if(tabbrowser.currentURI.spec!="about:blank"||
    tab.hasAttribute("wmntab")){
    tab=tabbrowser.addTab("about:blank");
  }
  if(name!=null)tab.setAttribute("wmntab",name);  
  var browser=tabbrowser.getBrowserForTab(tab);  
  if(sessionId!=null){
    if(this.multiSession)this.setSessionId(win,tab,sessionId);
    else tab.setAttribute("wmnid",sessionId); 
    //tab.setAttribute("wmnsid",sessionId);      
    //try{if(this.multiSession)browser.addProgressListener(this);}catch(e){}
  }
  browser.loadURIWithFlags(url);
  if(!this.prefBranch.getBoolPref("loadInBackground")){
    tabbrowser.selectedTab = tab;    
    win.focus();
  }
}
WebMailNotifier.prototype.setSessionId = function(win,tab,sid){
  if(sid==null||sid.toString()=="")sid=-1;
  if(sid==-1){
    tab.removeAttribute("wmnsid"); 
    var tabbrowser=win.getBrowser();  
    var browser=tabbrowser.getBrowserForTab(tab);      
    var doc=browser.contentDocument;
    try{
      if(doc.com.tobwithu.wmn.cookieGetter){
        var src=
          "doc.__defineGetter__('cookie',getter);\
          doc.__defineSetter__('cookie',setter);";
        var sandbox = new Components.utils.Sandbox(doc.defaultView);
        sandbox.doc=doc.wrappedJSObject;
        sandbox.getter=doc.com.tobwithu.wmn.cookieGetter;
        sandbox.setter=doc.com.tobwithu.wmn.cookieSetter;
        Components.utils.evalInSandbox(src,sandbox);
        delete doc.com.tobwithu.wmn.cookieGetter;
        delete doc.com.tobwithu.wmn.cookieSetter;
      }
    }catch(e){
dout("***"+e);
    }
  }else{
    tab.setAttribute("wmnsid",sid); 
    var tabbrowser=win.getBrowser();  
    var browser=tabbrowser.getBrowserForTab(tab);      
    try{browser.addProgressListener(this);}catch(e){}
  }  
}
WebMailNotifier.prototype.openNewWindow = function() {
    var win=Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
    win.open("about:blank");
}
WebMailNotifier.prototype.openWindow = function(url,name,reuse,mailDomain,sid) {
  this.openTab(url,name,reuse,mailDomain,sid,true);
}
WebMailNotifier.prototype.getWindow = function(notChrome) {
 /* var win=Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
              .getService(Components.interfaces.nsIWindowWatcher).activeWindow;
  if(win==null){*/
  var wm = Components.classes['@mozilla.org/appshell/window-mediator;1']
                      .getService(Components.interfaces.nsIWindowMediator);
  var win = wm.getMostRecentWindow("navigator:browser");
  if(win==null){
    win=Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;
    if(notChrome){
      win.open("about:blank");
      win = wm.getMostRecentWindow("navigator:browser");
    }
  }
  return win;
}
WebMailNotifier.prototype.openLink = function(url) {
  var  win=Components.classes["@mozilla.org/appshell/appShellService;1"]
                    .getService(Components.interfaces.nsIAppShellService).hiddenDOMWindow;  
  win.open(url);  
}
WebMailNotifier.prototype.openInTab = function(url){
  var win=this.getWindow(true);
  var browser=win.getBrowser();
  var tab=browser.addTab(url);
  browser.selectedTab = tab;  
}
